VERSION 5.00
Begin VB.Form games1 
   AutoRedraw      =   -1  'True
   Caption         =   "gamess control 1"
   ClientHeight    =   5235
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5790
   LinkTopic       =   "Form1"
   ScaleHeight     =   5235
   ScaleWidth      =   5790
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   WindowState     =   1  'Minimized
End
Attribute VB_Name = "games1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()
    
    Call Gamess_Adjust
    
End Sub

Private Sub Form_Load()

    'call the routine to send 20x20 angstrom coordinates
    ' in 0.1 angstrom steps in both x,y directions to gamess
    'we assume that the file input is "Input"

    Call Gamess_Adjust
    
    End

End Sub

Private Sub Gamess_Adjust()

'this routine reads the current batch file that called the last
'gamess run.  In the batch file, RunGame.bat, the gamess output
'file is specified as an i/o redirection.  In the outfile name
'is embedded the outfile number, ie the outfile name is coded as
'nnn_xxx_yyy.out, where nnn is a text descripter, xxx is the x
'coordinate*10+200, and yyy is the y coordinate*10+200.  From the
'outfile name then, the x,y coordinates of the last run are extracted
'and stored. xval, yval stores the actual xxx and yyy numbers (ie,
'coordinate*10 + 200).
'
'The code then process the xval,yval.  If both are at maximum, the code
'deletes the rungame.bat file, which in turn signals to the autogame.bat file
'that the sequenced run is done.
'
'If the run is not done, it increments y (til +10 angstroms, then resets y
'to -10 angstroms and increments x).  After incrementing x,y appropriately,
'reads the input file into the string array, and then adjusts the line with the
'coordinates of interest, and rewrites the input file.
'
'After the input file is written, RunGame.bat is rewritten with the updated
'outfile name, as determined from the new values for xval and yval.
'
'The program then exits; in this fashion, control information is stored in the
'batch file that actually calls the gamess code, RunGame.bat.


'constants
    Const xstringpos As String = 30     'the position in the line of RunGame.bat
                                        'that contains one of your automatic
                                        'coordinates.
    Const ystringpos As String = 34     'the position in the line of RunGame.bat
                                        'that contains the other automatic
                                        'coordinate
    Const InputFileName As String = "input"     'name of input file for GAMESS; this
                                                'will generally not be changed
    Const rungamename As String = "rungame.bat" 'you can change this name so you can
                                                'have multiple versions if you like.
    Const BoxWidth As Long = 200    'this is the total width of your "box" in
                                    'angstroms * 10
    Const CoordStep As Long = 1     'the coordinate increment, or mesh size, in
                                    'tenths of an angstrom
                                    
'These next three constants (two strings and one Long)are used to build the line in
'your input file; LeadString is the text that will go BEFORE the adjustable coordinates
'in that line, and TrailString is the remaining portion of the line, after the
'adjustable coordinates.
'
'For example, in my file, The adjustable line is the 18th line in the input file
'and will be written as
'
'   Argon11     18.0    xcoordinate    ycoordinate      0.0
'
'in a caresian GAMESS input format.
'
    Const AdjLineNum As Long = 18
    Const LeadString As String = "Argon11        18.0     "
    Const TrailString As String = "     0.0"

'integers
    Dim runGameFileHandle As Integer    'File Handle to access RunGame.bat
    Dim InputFileHandle As Integer      'File Handle to access Input
    Dim xstringpos As Integer       'Position of x coordinate in first line of
                                    'RunGame.bat
    Dim ystringpos As Integer       'position of y coordinate in first line of
                                    'RunGame.bat
    
'longs
    Dim xval As Long        'internal variable, x coordinate*10+200
    Dim yval As Long        'internal variable, y coordinate*10+200
    Dim linecount1 As Long  'internal counter for RunGame.bat lines
    Dim linecount2 As Long  'internal counter for Input lines
    Dim outcount As Long    'internal counter for outputing the Input lines

'strings
    Dim runGameLines(5) As String       'string array for lines of RunGame.bat
    Dim InputFileLines(25) As String    'string array for lines of Input
    Dim rungamename As String           'string to hold RunGame.bat file name
                                        'storing in string allows a single change
                                        'to be global in code
    Dim InputFileName As String         'string to hold name of input file.  Really
                                        'if this is passed directly to gamess without
                                        'any other outside processing, this should be
                                        'Input.
    Dim outfilexstring As String    'used to compute the x-coordinate portion of new outfile name
    Dim outfileystring As String    'used to compute the y=coordinate portion of new outfile name
    
    'set the working directory for the gamess calculations
    ChDir "c:\documents and settings\john riley\my documents\gamess"
      
    'get a free file handle
    runGameFileHandle = FreeFile(0)
    
    'open the RunGame.bat file, and read lines into string array
    'close it when done
    Open rungamename For Input As runGameFileHandle
    
    linecount1 = 1
    
    Do While Not EOF(runGameFileHandle)
    
        Line Input #runGameFileHandle, runGameLines(linecount1)
        Print runGameLines(linecount1)
        linecount1 = linecount1 + 1
        
    Loop
    
    Close runGameFileHandle
    
    'extract the values from the outfile name in RunGame.bat
    xval = Val(Mid$(runGameLines(1), xstringpos, 3))
    yval = Val(Mid$(runGameLines(1), ystringpos, 3))
    
    Print: Print Mid$(runGameLines(1), xstringpos, 3)
    Print Mid$(runGameLines(1), ystringpos, 3)
    
    Print
    
    Print xval, yval
    
    'if done with run, delete RunGame.bat and exit
    'otherwise adjust xval and yval, read input, adjust
    'input, rewrite input, adjust RunGame.bat and rewrite RunGame.bat
    If xval <= BoxWidth And yval <= BoxWidth Then
        
        If yval Mod BoxWidth = 0 And yval <> 0 Then 'if yval is at bottom of column
            yval = 0                     'reset to top of column and increment
            xval = xval + CoordStep      'row
        Else
            yval = yval + CoordStep         'otherwise increment column
        End If
        
        InputFileHandle = FreeFile(0)   'get a free file handle for Input
        
        'open the Input file, read into string array
        'close when done
        Open InputFileName For Input As InputFileHandle
        
            linecount2 = 1
               
               Do While Not EOF(InputFileHandle)
               
                  Line Input #InputFileHandle, InputFileLines(linecount2)
                  linecount2 = linecount2 + 1
                  
               Loop
        
        Close InputFileHandle
        
        'Adjust the line of interest to hold the new values for the coordinates
        InputFileLines(AdjLineNum) = LeadString & Str$((xval - 100) / 10) & "     " & Str$((yval - 100) / 10) & _
            TrailString

        'rewrite Input file after getting a free handle
        'and close when done
        InputFileHandle = FreeFile(0)
        
        Open InputFileName For Output As InputFileHandle
        
            For outcount = 1 To linecount2 - 1
                Print #InputFileHandle, InputFileLines(outcount)
            Next outcount
            
        Close InputFileHandle
        
        'adjust outfile name in RunGame.bat still stored in memory
        'outfilexstring and outfileystring are used to configure
        'the strings properly for output as a file name.
        outfilexstring = Str$(xval)
        outfileystring = Str$(yval)
        
        'the str$ function always adds a leading space to have room
        'for the sign of the number; the space must be removed
        outfilexstring = Right(outfilexstring, _
                Len(outfilexstring) - 1)
        outfileystring = Right(outfileystring, _
                Len(outfileystring) - 1)
        
        If xval = 0 Then outfilexstring = "000"
        If yval = 0 Then outfileystring = "000"
        
        'with the space removed, the string may well be less than
        'than 3 digits; pad with leading zeros if len < 3
        'do both x and y values
        Do While Len(outfilexstring) < 3
            outfilexstring = "0" & outfilexstring
        Loop
        
        Do While Len(outfileystring) < 3
            outfileystring = "0" & outfileystring
        Loop
        
        'Print: Print outfilexstring, xval
        'Print outfileystring, yval
        
        'insert the string'ed coordinates into the outfile name
        'to be written to line 1 of RunGame.bat.  The lines of
        'RunGame.bat are still stored in string array runGameLines()
        Mid$(runGameLines(1), xstringpos, 3) = outfilexstring
        Mid$(runGameLines(1), ystringpos, 3) = outfileystring
        
        'write new RunGame.bat after getting a free handle
        'and close when done
        runGameFileHandle = FreeFile(0)
        
        Open rungamename For Output As runGameFileHandle
        
            Print #runGameFileHandle, runGameLines(1)
            Print #runGameFileHandle, runGameLines(2)
        
        Close runGameFileHandle
    
    Else
    
        Kill rungamename
    
    End If
        
        

End Sub


